Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Axiom match_nat_prop : forall (return_:(nat -> Prop)), (return_ O) -> (forall (n:nat), return_ (S n)) -> forall (z:nat), return_ z.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Definition sym_eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) case_O (match_nat_type (return_type) case_O case_S O) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((eq_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Definition pred : nat -> nat := fun (n:nat) => match_nat_type (nat) O (fun (p:nat) => p) n.
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Parameter minus : nat -> nat -> nat.
Parameter minus_body : nat -> nat -> nat.
Axiom axiom_minus : forall (n:nat), connectives.equal (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n).
Definition eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((axiom_minus) (n)).
Definition sym_eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) minus_body n) (minus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((eq_minus) (n)).
Axiom axiom_minus_body_O : connectives.equal (nat -> nat) (minus_body O) (fun (m:nat) => O).
Definition eq_minus_body_O : leibniz.leibniz (nat -> nat) (minus_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (axiom_minus_body_O).
Definition sym_eq_minus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (minus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body O)) (fun (m:nat) => O)) (eq_minus_body_O).
Axiom axiom_minus_body_S : forall (n:nat), connectives.equal (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m).
Definition eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((axiom_minus_body_S) (n)).
Definition sym_eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) (minus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((eq_minus_body_S) (n)).
Definition nat_elim2 : forall (R:(nat -> nat -> Prop)), (forall (n:nat), R O n) -> (forall (n:nat), R (S n) O) -> (forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) -> forall (n:nat), forall (m:nat), R n m := fun (R:nat -> nat -> Prop) => fun (ROn:forall (n:nat), R O n) => (fun (RSO:forall (n:nat), R (S n) O) => (fun (RSS:forall (n:nat), forall (m:nat), (R n m) -> R (S n) (S m)) => (fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), R _x_365 m)) (fun (m:nat) => (ROn) (m))) (fun (n0:nat) => fun (Rn0m:forall (m:nat), R n0 m) => (fun (m:nat) => ((((match_nat_prop) (fun (__:nat) => R (S n0) __)) ((RSO) (n0))) (fun (auto:nat) => (((RSS) (n0)) (auto)) ((Rn0m) (auto)))) (m)))) (n)))).
Definition pred_Sn : forall (n:nat), logic.eq (nat) n (pred (S n)) := fun (n:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (n)) (fun (y:nat) => logic.eq (nat) n y)) (((logic.refl) (nat)) (n)).
Definition minus_O_n : forall (n:nat), logic.eq (nat) O (minus O n) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) O (minus O __))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) ((((sym_eq_minus) (O)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (minus_body)) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (((sym_eq_minus_body_O) (fun (y:(nat -> nat)) => forall (n0:nat), logic.eq (nat) O (y (S n0)))) (fun (auto:nat) => ((logic.refl) (nat)) (O)))))) (n).
Definition minus_n_O : forall (n:nat), logic.eq (nat) n (minus n O) := fun (n:nat) => ((((match_nat_prop) (fun (__:nat) => logic.eq (nat) __ (minus __ O))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (minus O O)) ((minus_O_n) (O)))) (fun (auto:nat) => (((sym_eq_minus) (S auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((sym_eq_minus_body_S) (auto)) (fun (y:(nat -> nat)) => logic.eq (nat) (S auto) (y O))) ((((((sym_eq_match_nat_type_O) (nat)) (S auto)) (fun (q:nat) => minus auto q)) (fun (y:nat) => logic.eq (nat) (S auto) y)) (((logic.refl) (nat)) (S auto))))))) (n).
Definition lt_to_not_zero : forall (n:nat), forall (m:nat), (lt n m) -> not_zero m := fun (n:nat) => fun (m:nat) => fun (Hlt:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => not_zero x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (fun (m0:nat) => fun (_x_419:le (S n) m0) => (fun (_x_421:not_zero m0) => (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (m0)) (fun (y:Prop) => y)) (connectives.I))))) (m)) (Hlt)).
Definition le_n_Sn : forall (n:nat), le n (S n) := fun (n:nat) => (((le_S) (n)) (n)) ((le_n) (n)).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition le_pred_n : forall (n:nat), le (pred n) n := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => le (pred _x_365) _x_365)) ((((((eq_match_nat_type_O) (nat)) (O)) (fun (p:nat) => p)) (fun (y:nat) => le (match_nat_type (nat) O (fun (p:nat) => p) O) y)) ((le_n) (pred O)))) (fun (x_366:nat) => fun (_x_368:le (pred x_366) x_366) => (((((((eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (x_366)) (fun (y:nat) => le (pred (S x_366)) (S y))) ((le_n_Sn) (pred (S x_366)))))) (n).
Definition monotonic_pred : relations.monotonic (nat) le pred := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (pred n) (pred x_417))) ((le_n) (pred n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (pred n) (pred m0)) => ((((((transitive_le) (pred n)) (n)) (pred (S m0))) ((le_pred_n) (n))) (((((((sym_eq_match_nat_type_S) (nat)) (O)) (fun (p:nat) => p)) (m0)) (fun (y:nat) => le n y)) (_x_419)))))) (m)) (lenm)).
Definition not_le_Sn_O : forall (n:nat), connectives.Not (le (S n) O) := fun (n:nat) => ((connectives.nmk) (le (S n) O)) (fun (Hlen0:le (S n) O) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) ((((lt_to_not_zero) (n)) (O)) (Hlen0)))).
Definition plus_minus : forall (m:nat), forall (n:nat), forall (p:nat), (le m n) -> logic.eq (nat) (plus (minus n m) p) (minus (plus n p) m) := ((((nat_elim2) (fun (__:nat) => fun (_0:nat) => forall (p:nat), (le __ _0) -> logic.eq (nat) (plus (minus _0 __) p) (minus (plus _0 p) __))) (fun (n:nat) => fun (p:nat) => fun (auto:le O n) => (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (nat) (plus __ p) (minus (plus n p) O))) (((((((logic.rewrite_l) (nat)) (plus n p)) (fun (__:nat) => logic.eq (nat) (plus n p) __)) (((logic.refl) (nat)) (plus n p))) (minus (plus n p) O)) ((minus_n_O) (plus n p)))) (minus n O)) ((minus_n_O) (n))))) (fun (n:nat) => fun (p:nat) => fun (abs:le (S n) O) => (((connectives.falsity) (logic.eq (nat) (plus (minus O (S n)) p) (minus (plus O p) (S n)))) ((((logic.absurd) (le (S n) O)) (abs)) ((not_le_Sn_O) (n)))))) (fun (n:nat) => fun (m:nat) => (((sym_eq_minus) (S m)) (fun (y:(nat -> nat)) => (forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) -> forall (p:nat), (le (S n) (S m)) -> logic.eq (nat) (plus (y (S n)) p) (minus (plus (S m) p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (m)) (fun (y:(nat -> nat)) => (forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) -> forall (p:nat), (le (S n) (S m)) -> logic.eq (nat) (plus (y (S n)) p) (minus (plus (S m) p) (S n)))) ((((sym_eq_minus_body_S) (m)) (fun (y:(nat -> nat)) => (forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) -> forall (p:nat), (le (S n) (S m)) -> logic.eq (nat) (plus (y (S n)) p) (minus (plus (S m) p) (S n)))) (fun (auto:forall (p:nat), (le n m) -> logic.eq (nat) (plus (minus m n) p) (minus (plus m p) n)) => (fun (p:nat) => ((((((sym_eq_match_nat_type_S) (nat)) (S m)) (fun (q:nat) => minus m q)) (n)) (fun (y:nat) => (le (S n) (S m)) -> logic.eq (nat) (plus y p) (minus (plus (S m) p) (S n)))) ((((sym_eq_minus) (plus (S m) p)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (y (S n)))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (filter_nat_type (nat -> nat) minus_body (y p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (filter_nat_type (nat -> nat) minus_body (y p) (S n)))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (filter_nat_type (nat -> nat) minus_body (y p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (plus m p)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (y (S n)))) ((((eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((((eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((eq_plus) (S m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (minus_body (y p) (S n)))) ((((sym_eq_minus_body_S) (plus m p)) (fun (y:(nat -> nat)) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) (y (S n)))) (((((((sym_eq_match_nat_type_S) (nat)) (S (plus m p))) (fun (q:nat) => minus (plus m p) q)) (n)) (fun (y:nat) => (le (S n) (S m)) -> logic.eq (nat) (plus (minus m n) p) y)) (fun (auto':le (S n) (S m)) => (((auto) (p)) (((((logic.eq_coerc) (le (pred (S n)) (pred (S m)))) (le n m)) ((((monotonic_pred) (S n)) (S m)) (auto'))) (((((((logic.rewrite_l) (nat)) (n)) (fun (__:nat) => logic.eq (Prop) (le __ (pred (S m))) (le n m))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le n __) (le n m))) (((logic.refl) (Prop)) (le n m))) (pred (S m))) ((pred_Sn) (m)))) (pred (S n))) ((pred_Sn) (n)))))))))))))))))))))))).
